/* Tag file for calling automatic code documenter prodox2.p.

prodox.p   Based on autodox.p - 2001 by Judy Hoffman Green, Joanju Limited

INPUT fileList
      Name of a file containing a list of program names
      (.w, .p, etc). One program name per line. Lines can
      be commented out by inserting lines containing nothing 
      but open comment (/*) and closing comment (*/).
*/

DEFINE INPUT PARAMETER fileList AS CHARACTER NO-UNDO.

DEFINE VARIABLE prodox  AS HANDLE NO-UNDO.

DEFINE VARIABLE outDir       AS CHARACTER INITIAL "c:\gord\proparse\xml\" NO-UNDO.
DEFINE VARIABLE outImageDir  AS CHARACTER INITIAL "c:\gord\proparse\img\" NO-UNDO.

REPEAT: 
  RUN prodox/textprompt2.w
    (INPUT "Enter the name of the directory for the "
           + "output XML files. File names in the file list should be "
           + "absolute. "
           + "Enter ./ for current (working) directory.",
     INPUT-OUTPUT outDir,
     INPUT "~n~nEnter the name of the directory for the "
           + "output Image files."
           + "Enter ./ for current (working) directory.",
     INPUT-OUTPUT outImageDir
    ).
  IF RETURN-VALUE = "cancel" THEN
     RETURN.

  IF LENGTH(outDir) > 0 
  AND SUBSTRING(outDir,LENGTH(outDir),1) <> "/"
  AND SUBSTRING(outDir,LENGTH(outDir),1) <> "~\"
  THEN DO: 
    MESSAGE "Please re-enter output directory name with a / or \ at the end." VIEW-AS ALERT-BOX. 
    UNDO, RETRY.
  END. 
  ELSE LEAVE.
END. 


RUN prodox/prodox2.p PERSISTENT SET prodox.

RUN setFileList       IN prodox (fileList).
RUN setOutputDir      IN prodox (outDir).
RUN setOutputImageDir IN prodox (outImageDir).

RUN setProcCommentLoc IN prodox (FALSE).    /* TRUE = Before, FALSE = After. See readme.html */
RUN setFuncCommentLoc IN prodox (FALSE).    /* TRUE = Before, FALSE = After. See readme.html */
RUN setParamCommentLoc IN prodox (FALSE).   /* TRUE = Before, FALSE = After. See readme.html */

RUN main IN prodox (prodox).

MESSAGE "XML Documentation complete!" VIEW-AS ALERT-BOX.

APPLY "CLOSE":U TO prodox.


