/* Form parser - creates images and identifies widgets/attributes per frame 
                 object

prodox3.p   

*/


DEFINE INPUT PARAMETER pcProc   AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER pcDir    AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER pcName   AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER phParent AS HANDLE NO-UNDO.

{ prodox/prodox.cfg }

DEFINE VARIABLE cAttributes AS CHARACTER NO-UNDO.

DEFINE VARIABLE prodox  AS HANDLE NO-UNDO.

DEFINE VARIABLE iFillIn AS INTEGER NO-UNDO.
DEFINE VARIABLE iText   AS INTEGER NO-UNDO.
DEFINE VARIABLE iButton AS INTEGER NO-UNDO.

DEFINE STREAM Sfly.

prodox = WIDGET-HANDLE(pcProc).

IF NOT VALID-HANDLE(prodox) THEN DO:
  MESSAGE "This procedure must be called from prodox.p !" 
          VIEW-AS ALERT-BOX ERROR.
  RETURN.
END.

FUNCTION DrawBackground RETURNS LOGICAL
  (INPUT BackWidth  AS INTEGER,
   INPUT BackHeight AS INTEGER):

  PUT STREAM Sfly UNFORMATTED 
      "frect 0,0," BackWidth "," BackHeight ",{&FlyBackground}" SKIP.

  RETURN TRUE.
END FUNCTION. /* DrawBackground */

FUNCTION DrawButton RETURNS LOGICAL
  (INPUT ph         AS HANDLE):

  iButton = iButton + 1.

  PUT STREAM Sfly UNFORMATTED
      "rect " ph:X "," 
              ph:y "," 
              ph:X + ph:WIDTH-PIXELS "," 
              ph:Y + ph:HEIGHT-PIXELS ","
              "{&FlyButtonBorder}" SKIP.

  PUT STREAM Sfly UNFORMATTED
      "frect " ph:X + 1 "," 
               ph:y + 1 "," 
               ph:X + ph:WIDTH-PIXELS - 2 "," 
               ph:Y + ph:HEIGHT-PIXELS - 2 ","
              "{&FlyButtonFill}" SKIP.

  PUT STREAM Sfly UNFORMATTED
      "string {&FlyButtonText}," 
               ph:X + 2 "," 
               (IF iButton MODULO 2 = 0 THEN ph:Y + ph:HEIGHT-PIXELS - 8 ELSE ph:Y) "," 
               "{&FlyButtonTextSize}," 
               ph:NAME SKIP.

  RETURN TRUE.
END FUNCTION. /* DrawButton */


FUNCTION DrawFillIn RETURNS LOGICAL
  (INPUT ph         AS HANDLE):

  iFillIn = iFillIn + 1.

  PUT STREAM Sfly UNFORMATTED
      "rect " ph:X "," 
              ph:y "," 
              ph:X + ph:WIDTH-PIXELS "," 
              ph:Y + ph:HEIGHT-PIXELS ","
              "{&FlyFillInBorder}" SKIP.

  PUT STREAM Sfly UNFORMATTED
      "frect " ph:X + 1 "," 
               ph:y + 1 "," 
               ph:X + ph:WIDTH-PIXELS - 2 "," 
               ph:Y + ph:HEIGHT-PIXELS - 2 ","
              "{&FlyFillInFill}" SKIP.

  PUT STREAM Sfly UNFORMATTED
      "string {&FlyFillInText}," 
               ph:X + 2 "," 
               ph:Y + ph:HEIGHT-PIXELS - 8 "," 
               "{&FlyFillInTextSize}," 
               ph:NAME SKIP.

  RETURN TRUE.
END FUNCTION. /* DrawFillIn */

FUNCTION DrawRectangle RETURNS LOGICAL
  (INPUT ph   AS HANDLE):

  PUT STREAM Sfly UNFORMATTED
      "rect " ph:X "," 
              ph:y "," 
              ph:X + ph:WIDTH-PIXELS "," 
              ph:Y + ph:HEIGHT-PIXELS ","
              "{&FlyRectangleBorder}" SKIP.

  RETURN TRUE.
END FUNCTION. /* DrawRectangle */

FUNCTION DrawToggleBox RETURNS LOGICAL
  (INPUT ph   AS HANDLE):

  PUT STREAM Sfly UNFORMATTED
      "frect " ph:X  "," 
               ph:y  "," 
               ph:X + 10 "," 
               ph:Y + 10 ","
              "{&FlyToggleBoxFill}" SKIP.

  PUT STREAM Sfly UNFORMATTED
      "string {&FlyToggleBoxText}," 
               ph:X + 12 "," 
               ph:Y + 8  "," 
               "{&FlyToggleBoxTextSize}," 
               ph:NAME SKIP.

  PUT STREAM Sfly UNFORMATTED
      "string {&FlyToggleBoxLabel}," 
               ph:X + 12 "," 
               ph:Y   "," 
               "{&FlyToggleBoxTextSize}," 
               ph:LABEL SKIP.

  RETURN TRUE.
END FUNCTION. /* DrawToggleBox */

FUNCTION DrawComboBox RETURNS LOGICAL
  (INPUT ph   AS HANDLE):

  PUT STREAM Sfly UNFORMATTED
      "frect " ph:X  "," 
               ph:y  "," 
               ph:X + ph:WIDTH-PIXELS - 40 "," 
               ph:Y + ph:HEIGHT-PIXELS ","
              "{&FlyComboBoxFill}" SKIP.

  PUT STREAM Sfly UNFORMATTED
      "string {&FlyComboBoxText}," 
               ph:X + 2 "," 
               ph:Y + 8  "," 
               "{&FlyComboBoxTextSize}," 
               ph:NAME SKIP.

  RETURN TRUE.
END FUNCTION. /* DrawComboBox */

FUNCTION DrawCheckBox RETURNS LOGICAL
  (INPUT ph   AS HANDLE):

  PUT STREAM Sfly UNFORMATTED
      "frect " ph:X  "," 
               ph:y  "," 
               ph:X + ph:WIDTH-PIXELS "," 
               ph:Y + ph:HEIGHT-PIXELS ","
              "{&FlyCheckBoxFill}" SKIP.

  PUT STREAM Sfly UNFORMATTED
      "string {&FlyCheckBoxText}," 
               ph:X + 2 "," 
               ph:Y + ph:HEIGHT-PIXELS - 8 "," 
               "{&FlyCheckBoxTextSize}," 
               ph:NAME SKIP.

  RETURN TRUE.
END FUNCTION. /* DrawCheckBox */

FUNCTION DrawSelectionList RETURNS LOGICAL
  (INPUT ph   AS HANDLE):

  PUT STREAM Sfly UNFORMATTED
      "frect " ph:X + 1 "," 
               ph:y + 1 "," 
               ph:X + ph:WIDTH-PIXELS - 2 "," 
               ph:Y + ph:HEIGHT-PIXELS - 2 ","
              "{&FlySelectionListFill}" SKIP.

  PUT STREAM Sfly UNFORMATTED
      "string {&FlySelectionListText}," 
               ph:X + 2 "," 
               ph:Y + ph:HEIGHT-PIXELS - 8 "," 
               "{&FlySelectionListTextSize}," 
               ph:NAME SKIP.

  RETURN TRUE.
END FUNCTION. /* DrawSelectionList */

FUNCTION DrawControlFrame RETURNS LOGICAL
  (INPUT ph   AS HANDLE):

  DEFINE VARIABlE chCOM AS COM-HANDLE NO-UNDO.

  chCOM = ph:COM-HANDLE.

  PUT STREAM Sfly UNFORMATTED
      "rect " ph:X + 1 "," 
              ph:y + 1 "," 
              ph:X + ph:WIDTH-PIXELS - 2 "," 
              ph:Y + ph:HEIGHT-PIXELS - 2 ","
              "{&FlyControlFrameBorder}" SKIP.

  PUT STREAM Sfly UNFORMATTED
      "string {&FlyControlFrameText}," 
               ph:X + 2 "," 
               ph:Y + 2 "," 
               "{&FlyControlFrameTextSize}," 
               "ActiveX" SKIP.

  RETURN TRUE.
END FUNCTION. /* DrawControlFrame */

FUNCTION DrawEditor RETURNS LOGICAL
  (INPUT ph   AS HANDLE):

  PUT STREAM Sfly UNFORMATTED
      "frect " ph:X + 1 "," 
               ph:y + 1 "," 
               ph:X + ph:WIDTH-PIXELS - 2 "," 
               ph:Y + ph:HEIGHT-PIXELS - 2 ","
               "{&FlyEditorFill}" SKIP.

  PUT STREAM Sfly UNFORMATTED
      "string {&FlyEditorText}," 
               ph:X + 2 "," 
               ph:Y + 2 "," 
               "{&FlyEditorTextSize}," 
               ph:NAME SKIP.

  RETURN TRUE.
END FUNCTION. /* DrawEditor */

FUNCTION DrawImage RETURNS LOGICAL
  (INPUT ph   AS HANDLE):

  PUT STREAM Sfly UNFORMATTED
      "frect " ph:X + 1 "," 
               ph:y + 1 "," 
               ph:X + ph:WIDTH-PIXELS - 2 "," 
               ph:Y + ph:HEIGHT-PIXELS - 2 ","
               "{&FlyImageFill}" SKIP.

  PUT STREAM Sfly UNFORMATTED
      "string {&FlyImageText}," 
               ph:X + 2 "," 
               ph:Y + 2 "," 
               "{&FlyImageTextSize}," 
               ph:NAME SKIP.

  RETURN TRUE.
END FUNCTION. /* DrawImage */

FUNCTION DrawRadioSet RETURNS LOGICAL
  (INPUT ph   AS HANDLE):

  DEFINE VARIABLE iButtons  AS INTEGER NO-UNDO.
  DEFINE VARIABLE iLoop     AS INTEGER NO-UNDO.
  DEFINE VARIABLE iY        AS INTEGER NO-UNDO.

  PUT STREAM Sfly UNFORMATTED
      "frect " ph:X "," 
               ph:y "," 
               ph:X + ph:WIDTH-PIXELS "," 
               ph:Y + ph:HEIGHT-PIXELS  ","
              "{&FlyRadioSetFill}" SKIP.

  PUT STREAM Sfly UNFORMATTED
      "string {&FlyRadioSetText}," 
               ph:X + 2 "," 
               ph:Y + ph:HEIGHT-PIXELS - 8 "," 
               "{&FlyRadioSetTextSize}," 
               ph:NAME SKIP.

  iButtons = NUM-ENTRIES(ph:RADIO-BUTTONS).
  iY       = ph:Y.

  PUT STREAM Sfly UNFORMATTED
      "string {&FlyRadioSetOptionText}," 
               ph:X + 2 "," 
               iY "," 
               "{&FlyRadioSetTextSize}," 
               ph:NAME SKIP.

  IF iButtons > 0 THEN DO iLoop = 1 TO iButtons BY 2:

    PUT STREAM Sfly UNFORMATTED
        "string {&FlyRadioSetOptionText}," 
                 ph:X + 2 "," 
                 iY + 8 "," 
                 "{&FlyRadioSetTextSize}," 
                 ENTRY(iLoop,ph:RADIO-BUTTONS) SKIP.

    iY = iY + 8.

  END.

  RETURN TRUE.
END FUNCTION. /* DrawRadioSet */

FUNCTION DrawBrowse RETURNS LOGICAL
  (INPUT ph   AS HANDLE):

  DEFINE VARIABLE cOutput   AS CHARACTER NO-UNDO.
  DEFINE VARIABLE hHandle   AS HANDLE NO-UNDO.
  DEFINE VARIABLE hField    AS HANDLE NO-UNDO.
  DEFINE VARIABLE hQuery    AS HANDLE NO-UNDO.
  DEFINE VARIABLE iLoop     AS INTEGER NO-UNDO.

  PUT STREAM Sfly UNFORMATTED
      "frect " ph:X "," 
               ph:y "," 
               ph:X + ph:WIDTH-PIXELS "," 
               ph:Y + ph:HEIGHT-PIXELS  ","
              "{&FlyBrowseFill}" SKIP.

  PUT STREAM Sfly UNFORMATTED
      "string {&FlyBrowseText}," 
               ph:X + 2 "," 
               ph:Y "," 
               "{&FlyBrowseTextSize}," 
               "Name: " + ph:NAME SKIP.

  /* Output the Buffers associated with the Browse */
  hQuery = ph:QUERY.
  IF VALID-HANDLE(hQuery) THEN DO:
    DO iLoop = 1 TO hQUery:NUM-BUFFERS:
      hHandle = hQuery:GET-BUFFER-HANDLE(iLoop).

      cOutput = IF iLoop = 1 THEN
                  hHandle:NAME
                ELSE
                  cOutput + "," + hHandle:NAME.
    END.

    PUT STREAM Sfly UNFORMATTED
        "string {&FlyBrowseText}," 
                 ph:X + 2 "," 
                 ph:Y + 8 "," 
                 "{&FlyBrowseTextSize}," 
                 "Buffers: " + cOutput SKIP.
  END.

  /* Output the Columns associated with the Browse */
  DO iLoop = 1 TO ph:NUM-COLUMNS:
    hHandle = ph:GET-BROWSE-COLUMN(iLoop).
    hField = hHandle:BUFFER-FIELD.

    IF VALID-HANDLE(hField) THEN
      cOutput = IF iLoop = 1 THEN
                  hField:NAME
                ELSE
                  cOutput + "," + hField:NAME.

    IF cOutput <> "" THEN
      PUT STREAM Sfly UNFORMATTED
          "string {&FlyBrowseText}," 
                   ph:X + 2 "," 
                   ph:Y + 16 "," 
                   "{&FlyBrowseTextSize}," 
                   "Columns: " + cOutput SKIP.

  END.

  RETURN TRUE.
END FUNCTION. /* DrawBrowse */

FUNCTION DrawText RETURNS LOGICAL
  (INPUT ph   AS HANDLE):

  DEFINE VARIABLE cColor  AS CHARACTER NO-UNDO.

  PUT STREAM Sfly UNFORMATTED
      "string {&FlyTextText}," 
               ph:X + 2 "," 
               ph:Y "," 
               "{&FlyTextTextSize}," 
               ph:SCREEN-VALUE SKIP.

  IF ph:TYPE = "TEXT" THEN
    cColor = "{&FlyTextBorder}".
  ELSE
    cColor = "{&FlyLiteralBorder}".

  PUT STREAM Sfly UNFORMATTED
      "rect " ph:X "," 
              ph:y "," 
              ph:X + ph:WIDTH-PIXELS "," 
              ph:Y + ph:HEIGHT-PIXELS  ","
             cColor SKIP.

  IF ph:TYPE = "TEXT" THEN DO:
    PUT STREAM Sfly UNFORMATTED
        "string {&FlyTextText}," 
                 ph:X + 2 "," 
                 ph:Y + 3 "," 
                 "{&FlyTextTextSize}," 
                 ph:NAME SKIP.

  END.

  RETURN TRUE.
END FUNCTION. /* DrawText */


OUTPUT STREAM Sfly TO VALUE(pcDir + pcName + ".fly").

PUT STREAM Sfly UNFORMATTED 
    "new"         SKIP
    "size " phParent:WIDTH-PIXELS "," phParent:HEIGHT-PIXELS SKIP
    "type {&FlyType}" SKIP.

/* Draw a 'nice' background colour */
DrawBackground(phParent:WIDTH-PIXELS,
               phParent:HEIGHT-PIXELS).

/* Now Draw all the Widgets by walking the widget tree for the frame */
DEFINE VARIABLE h AS HANDLE NO-UNDO.

ASSIGN h = phParent:FIRST-CHILD
       h = h:FIRST-CHILD.

DO WHILE VALID-HANDLE(h):

  CASE h:TYPE:
    WHEN "FILL-IN" THEN DO:
      DrawFillIn(h).
      cAttributes = "{&FillInAttributes}".
    END.

    WHEN "TEXT" OR WHEN "LITERAL" THEN DO:
      DrawText(h).
      cAttributes = "{&TextAttributes}".
    END.

    WHEN "BUTTON" THEN DO:
      DrawButton(h).
      cAttributes = "{&ButtonAttributes}".
    END.

    WHEN "RECTANGLE" THEN DO:
      DrawRectangle(h).
      cAttributes = "{&RectangleAttributes}".
    END.

    WHEN "BROWSE" THEN DO:
      DrawBrowse(h).
      cAttributes = "{&BrowseAttributes}".
    END.

    WHEN "SELECTION-LIST" THEN DO:
      DrawSelectionList(h).
      cAttributes = "{&SelectionListAttributes}".
    END.

    WHEN "TOGGLE-BOX" THEN DO:
      DrawToggleBox(h).
      cAttributes = "{&ToggleBoxAttributes}".
    END.

    WHEN "COMBO-BOX" THEN DO:
      DrawComboBox(h).
      cAttributes = "{&ComboBoxAttributes}".
    END.

    WHEN "CHECK-BOX" THEN DO:
      DrawCheckBox(h).
      cAttributes = "{&CheckBoxAttributes}".
    END.

    WHEN "RADIO-SET" THEN DO:
      DrawRadioSet(h).
      cAttributes = "{&RadioSetAttributes}".
    END.

    WHEN "CONTROL-FRAME" THEN DO:
      DrawControlFrame(h).
      cAttributes = "{&ControlFrameAttributes}".
    END.

    WHEN "EDITOR" THEN DO:
      DrawEditor(h).
      cAttributes = "{&EditorAttributes}".
    END.

    WHEN "IMAGE" THEN DO:
      DrawImage(h).
      cAttributes = "{&ImageAttributes}".
    END.

    OTHERWISE DO:
      message h:Type view-as alert-box.
      cAttributes = ?.
    END.

  END CASE.

  IF cAttributes <> ? THEN
    RUN AddWidget (h).

  ASSIGN h = h:NEXT-SIBLING.
END.

OUTPUT STREAM Sfly CLOSE.

/* Produce the Image */
OS-COMMAND SILENT VALUE("{&Fly} -i " + pcDir + pcName + ".fly -o "
                        + pcDir + pcName + "-" + phParent:NAME + ".{&FlyType}").

/* Cleanup */
OS-DELETE VALUE(pcDir + pcName + ".fly").

/* -------------------- INTERNAL PROCEDURE ----------------------- */
PROCEDURE addWidget:
  DEFINE INPUT PARAMETER ph AS HANDLE NO-UNDO.

  DEFINE VARIABLE cAttribute  AS CHARACTER NO-UNDO.

  DEFINE VARIABLE iAttributes AS INTEGER NO-UNDO.
  DEFINE VARIABLE iLoop       AS INTEGER NO-UNDO.

  DEFINE VARIABLE hCall       AS HANDLE NO-UNDO.

  RUN addWidget IN prodox (INPUT phParent:NAME,
                           INPUT ph:NAME,
                           INPUT STRING(ph),
                           INPUT ph:TYPE).

  iAttributes = NUM-ENTRIES(LIST-QUERY-ATTRS(ph)).

  CREATE CALL hCall.

  ATT-LOOP:
  DO iLoop = 1 TO iAttributes:

    cAttribute = ENTRY(iLoop,LIST-QUERY-ATTRS(ph)).

    IF LOOKUP(cAttribute,cAttributes) = 0 THEN NEXT ATT-LOOP.

    hCall:CLEAR().

    hCall:IN-HANDLE = ph.
    hCall:CALL-TYPE = GET-ATTR-CALL-TYPE.
    hCall:CALL-NAME = cAttribute.

    hCall:INVOKE() NO-ERROR.

    IF ERROR-STATUS:NUM-MESSAGES = 0 THEN DO:
      RUN addAttribute IN prodox (INPUT phParent:NAME,
                                  INPUT STRING(ph),
                                  INPUT cAttribute,
                                  INPUT string(hCall:RETURN-VALUE)).
    END.
  END.

  DELETE OBJECT hCall.
 
END. /* addWidget */
